
(* PRACTICA 6: ESTRUCTURAS DE DATOS AVANZADAS.
   1 B SISTEMAS.
   Implementacion del Servidor de Correo.

   NOTA IMPORTANTE:
     (1) La variable de error se usa para propagar el error
     (2) Los tipos Abstractos- Red y Cola- son opaco.
     (3) Importante fijarse en como se propaga el error
     desde la cola al Servidor de Correo y como se evitan las operaciones
     de E/S en los procedmientos en los casos en los que no
     son necesarias.

    PROFESOR: ANTONIO JOSE FERNANDEZ LEIVA  *)

MODULE Dcorreo;

FROM IO IMPORT WrStr,WrLn,RdStr,RdKey,RdChar,WrChar,
               RdCard,WrCard, KeyPressed;
FROM Window IMPORT Clear;
FROM Servidor IMPORT ERROR,CrearRed,AltaUsuario,BajaUsuario,CambiarPassword,
                    EnviarMsg,LeerMsg,DestruirRed,TRed;
FROM Cadena IMPORT Tcadena;

VAR
  r:TRed;
  error:ERROR;
  op,sal,basura:CHAR;
  nombre,nombre2,clave,oldclave,mensaje:Tcadena;

PROCEDURE Menu():CHAR;
          VAR
            opcion:CHAR;

          BEGIN
              Clear;
              WrStr('1 - Alta de usuario');WrLn;
              WrStr('2 - Baja de usuario');WrLn;
              WrStr('3 - Cambiar clave secreta');WrLn;
              WrStr('4 - Enviar mensaje');WrLn;
              WrStr('5 - Leer mensaje');WrLn;
              WrStr('S - Salir (S/N)');WrLn;
              opcion:=RdKey();
              WrChar(opcion);
              RETURN (opcion);
END Menu;

PROCEDURE pausa();
BEGIN
  REPEAT UNTIL KeyPressed()
END pausa;

(*Procedimiento que visualiza el tipo de error encontrado *)

PROCEDURE VerError(e:ERROR);
          BEGIN
              CASE e OF
                   |SinError  :;
                   |SinMemo   :WrLn;WrStr('--- Error, no hay memoria ---');
                               pausa;
                   |YaEsta    :WrLn;WrStr('--- Error, el usuario ya existe ---');
                               pausa;
                   |NoEsta    :WrLn;WrStr('--- Error, el usuario no existe ---');
                               pausa;
                   |SinAcceso :WrLn;WrStr('--- Error, no tiene acceso ---');
                               pausa
                   |Estructura:WrLn;WrStr('--- Error en la estructura interna ---');
                               pausa;
                   |SinMensajes:WrLn;WrStr('---  no tiene mensajes ---');
                               pausa;
              END;
END VerError;


BEGIN
    CrearRed(r,error);               (*IMPORTANTE!!! *)
    VerError(error);
    REPEAT
         op:=Menu();WrLn;
         CASE CAP(op) OF
            |  '1' : WrStr('Introduce tu nombre : ');
                     RdStr(nombre);
                     WrStr('Introduce clave : ');
                     RdStr(clave);
                     AltaUsuario(r,nombre,clave,error);
                     VerError(error);
            |  '2' : WrStr('Introduce el nombre : ');
                     RdStr(nombre);
                     BajaUsuario(r,nombre,error);
                     VerError(error);
            |  '3' : WrStr('Introduce tu nombre : ');
                     RdStr(nombre);
                     WrStr('Introduce clave antigua : ');
                     RdStr(oldclave);
                     WrStr('Introduce clave nueva: ');
                     RdStr(clave);
                     CambiarPassword(r,nombre,oldclave,clave,error);
                     VerError(error);
            |  '4' : WrStr('Introduce tu nombre : ');
                     RdStr(nombre);
                     WrStr('Introduce el nombre del destino : ');
                     RdStr(nombre2);
                     WrStr('Introduce el mensaje : ');
                     RdStr(mensaje);
                     EnviarMsg(r,nombre,nombre2,mensaje,error);
                     VerError(error);
            |  '5' : WrStr('Introduce tu nombre : ');
                     RdStr(nombre);
                     WrStr('Introduce clave : ');
                     RdStr(clave);
                     LeerMsg(r,nombre,clave,mensaje,error);
                     VerError(error);
                     IF error=SinError THEN
                        WrStr(mensaje);       (* Solo visualiza el mensaje si
                                                 no hubo errores *)
                     END;
            |  'S' : WrStr('Estas seguro que quires salir (S/N) : ');
                     sal:=RdKey();
         ELSE
            WrLn;
            WrStr('Error en la opcion');WrLn;
         END;
         IF CAP(op)#'S' THEN
            WrLn;
            WrStr('Pulsa una tecla ');
            basura:=RdKey();
         END
    UNTIL CAP(sal)='S';
    DestruirRed(r,error);          (* IMPORTANTE !!!! *)
    VerError(error);
END Dcorreo.