IMPLEMENTATION MODULE Servidor;

IMPORT Cola;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM Cadena IMPORT Comparar,Concatena,Copiar;

TYPE
   TRed=POINTER TO LUsuarios;
   LUsuarios=RECORD
                  nom:Tcadena;
                  pass:Tcadena;
                  buzon:Cola.Tcola;
                  sig:TRed;
   END;


PROCEDURE traduce(errorCola:Cola.ERROR;VAR error:ERROR);
BEGIN
   CASE errorCola OF
     Cola.SinError  : error:=SinError |
     Cola.NoMemoria : error:=SinMemo |
     Cola.Vacia     :error:=SinMensajes |
     Cola.NoCreada  :error:=Estructura
   END;
END traduce;

PROCEDURE CrearRed(VAR r:TRed;VAR  error:ERROR);
BEGIN
   error:=SinError;
   r:=NIL;
END CrearRed;

PROCEDURE Esta(r:TRed;nombre:Tcadena):BOOLEAN;
(* Mira si esta en la red un nombre *)
BEGIN
  WHILE (r#NIL) AND (Comparar(r^.nom,nombre)#0) DO
    r:=r^.sig;
  END;
  RETURN r#NIL;
END Esta;

PROCEDURE Insertar(VAR r:TRed;usuario:TRed);
(* inserto ordenadamente en la red sabiendo que no existe *)
          VAR
            ant,pos:TRed;
          BEGIN
              ant:=NIL;
              pos:=r;
              WHILE (pos#NIL) AND (Comparar(pos^.nom,usuario^.nom)=-1)DO
                    ant:=pos;
                    pos:=pos^.sig;
              END;
              IF ant=NIL THEN
                 r:=usuario;
              ELSE
                 ant^.sig:=usuario;
              END;
              usuario^.sig:=pos;
END Insertar;

PROCEDURE AltaUsuario(VAR r:TRed;nombre,password:Tcadena;VAR error:ERROR);
          VAR
            aux:TRed;
            errorCola:Cola.ERROR;
          BEGIN
              error:=SinError;
              IF NOT(Available(SIZE(aux^))) THEN
                 error:=SinMemo;
              ELSIF Esta(r,nombre) THEN
                    error:=YaEsta;
              ELSE
                 NEW(aux);
                 Copiar(aux^.nom,nombre);
                 Copiar(aux^.pass,password);
                 Cola.CrearCola(aux^.buzon,errorCola);
                 traduce(errorCola,error);
                 aux^.sig:=NIL;
                 Insertar(r,aux);
              END;
END AltaUsuario;

PROCEDURE BajaUsuario(VAR r:TRed;nombre:Tcadena;VAR error:ERROR);
          VAR
            ant,pos:TRed;
            errorCola:Cola.ERROR;
          BEGIN
              error:=SinError;
              IF NOT(Esta(r,nombre))THEN
                 error:=NoEsta;
              ELSE
                 ant:=NIL;
                 pos:=r;
                 WHILE (Comparar(pos^.nom,nombre)#0)DO (*Sabemos que esta *)
                       ant:=pos;
                       pos:=pos^.sig;
                 END;
                 IF ant=NIL THEN
                    r:=r^.sig;
                 ELSE
                    ant^.sig:=pos^.sig;
                 END;
                 Cola.DestruirCola(pos^.buzon,errorCola);  (* IMPORTANTE!!! *)
                 traduce(errorCola,error);
                 DISPOSE(pos);
              END;
END BajaUsuario;

PROCEDURE CambiarPassword(VAR r:TRed;nombre,oldpass,newpass:Tcadena;VAR error:ERROR);
          VAR
            aux:TRed;
          BEGIN
              error:=SinError;
              IF NOT(Esta(r,nombre)) THEN
                 error:=NoEsta;
              ELSE
                  aux:=r;
                  WHILE (Comparar(aux^.nom,nombre)#0)DO
                        aux:=aux^.sig;
                  END;
                  IF Comparar(oldpass,aux^.pass)=0 THEN
                     aux^.pass:=newpass;
                  ELSE
                     error:=SinAcceso;
                  END;
              END;
END CambiarPassword;

PROCEDURE EnviarMsg(VAR r:TRed;origen,destino,mensaje:Tcadena;VAR error:ERROR);
          VAR
            aux:TRed;
            mensa:Tcadena;
            errorCola:Cola.ERROR;
          BEGIN
              error:=SinError;
              IF (NOT(Esta(r,destino)))OR(NOT(Esta(r,origen))) THEN
                 error:=NoEsta;
              ELSE
                  aux:=r;
                  Concatena(mensa,origen,mensaje);
                  WHILE (aux#NIL)AND(Comparar(aux^.nom,destino)#0)DO
                        aux:=aux^.sig;
                  END;
                  Cola.MeterCola(aux^.buzon,mensa,errorCola);
                  traduce(errorCola,error);
              END;
END EnviarMsg;

PROCEDURE LeerMsg(VAR r:TRed;nombre,password:Tcadena;VAR msg:Tcadena;VAR error:ERROR);
          VAR
            aux:TRed;
            mensa:Tcadena;
            vacia:BOOLEAN;
            errorCola:Cola.ERROR;
          BEGIN
              error:=SinError;
              IF NOT(Esta(r,nombre)) THEN
                 error:=NoEsta;
              ELSE
                  aux:=r;
                  WHILE (aux#NIL)AND(Comparar(aux^.nom,nombre)#0)DO
                        aux:=aux^.sig;
                  END;
                  IF Comparar(aux^.pass,password)<>0 THEN
                     error:=SinAcceso
                  ELSE
                     vacia:=Cola.ColaVacia(aux^.buzon,errorCola);
                     IF vacia AND  (errorCola=Cola.SinError) THEN
                       error:=SinMensajes;
                     ELSIF errorCola<>Cola.SinError THEN
                       traduce(errorCola,error)
                     ELSE
                       Cola.SacarCola(aux^.buzon,msg,errorCola);
                       traduce(errorCola,error);
                     END;
                  END;
             END;
END LeerMsg;

PROCEDURE DestruirRed(VAR r:TRed;VAR error:ERROR);
          VAR
            aux:TRed;
            errorCola:Cola.ERROR;
          BEGIN
              error:=SinError;
              aux:=r;
              WHILE aux#NIL DO
                    r:=r^.sig;
                    Cola.DestruirCola(aux^.buzon,errorCola);
                    traduce(errorCola,error);
                    DISPOSE(aux);
                    aux:=r;
              END;
END DestruirRed;

END Servidor.